/*
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * THIS FILE WAS GENERATED BY codergen. EDIT WITH CARE.
 */
package com.android.tools.idea.editors.gfxtrace.service;

import com.android.tools.rpclib.schema.*;
import com.android.tools.idea.editors.gfxtrace.service.path.CapturePath;
import com.android.tools.idea.editors.gfxtrace.service.path.DevicePath;
import com.android.tools.rpclib.binary.*;
import org.jetbrains.annotations.NotNull;

import java.io.IOException;

final class CallGetTimingInfo implements BinaryObject {
  //<<<Start:Java.ClassBody:1>>>
  private DevicePath myDevice;
  private CapturePath myCapture;
  private TimingFlags myFlags;

  // Constructs a default-initialized {@link CallGetTimingInfo}.
  public CallGetTimingInfo() {}


  public DevicePath getDevice() {
    return myDevice;
  }

  public CallGetTimingInfo setDevice(DevicePath v) {
    myDevice = v;
    return this;
  }

  public CapturePath getCapture() {
    return myCapture;
  }

  public CallGetTimingInfo setCapture(CapturePath v) {
    myCapture = v;
    return this;
  }

  public TimingFlags getFlags() {
    return myFlags;
  }

  public CallGetTimingInfo setFlags(TimingFlags v) {
    myFlags = v;
    return this;
  }

  @Override @NotNull
  public BinaryClass klass() { return Klass.INSTANCE; }


  private static final Entity ENTITY = new Entity("service", "callGetTimingInfo", "", "");

  static {
    ENTITY.setFields(new Field[]{
      new Field("device", new Pointer(new Struct(DevicePath.Klass.INSTANCE.entity()))),
      new Field("capture", new Pointer(new Struct(CapturePath.Klass.INSTANCE.entity()))),
      new Field("flags", new Primitive("TimingFlags", Method.Int32)),
    });
    Namespace.register(Klass.INSTANCE);
  }
  public static void register() {}
  //<<<End:Java.ClassBody:1>>>
  public enum Klass implements BinaryClass {
    //<<<Start:Java.KlassBody:2>>>
    INSTANCE;

    @Override @NotNull
    public Entity entity() { return ENTITY; }

    @Override @NotNull
    public BinaryObject create() { return new CallGetTimingInfo(); }

    @Override
    public void encode(@NotNull Encoder e, BinaryObject obj) throws IOException {
      CallGetTimingInfo o = (CallGetTimingInfo)obj;
      e.object(o.myDevice);
      e.object(o.myCapture);
      e.int32(o.myFlags.getNumber());
    }

    @Override
    public void decode(@NotNull Decoder d, BinaryObject obj) throws IOException {
      CallGetTimingInfo o = (CallGetTimingInfo)obj;
      o.myDevice = (DevicePath)d.object();
      o.myCapture = (CapturePath)d.object();
      o.myFlags = TimingFlags.valueOf(d.int32());
    }
    //<<<End:Java.KlassBody:2>>>
  }
}
