/*
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * THIS FILE WAS GENERATED BY codergen. EDIT WITH CARE.
 */
package com.android.tools.idea.editors.gfxtrace.service;

import com.android.tools.rpclib.schema.*;
import com.android.tools.idea.editors.gfxtrace.service.memory.MemoryRange;
import com.android.tools.rpclib.binary.*;
import org.jetbrains.annotations.NotNull;

import java.io.IOException;

public final class MemoryInfo implements BinaryObject {
  //<<<Start:Java.ClassBody:1>>>
  private byte[] myData;
  private MemoryRange[] myReads;
  private MemoryRange[] myWrites;
  private MemoryRange[] myObserved;

  // Constructs a default-initialized {@link MemoryInfo}.
  public MemoryInfo() {}


  public byte[] getData() {
    return myData;
  }

  public MemoryInfo setData(byte[] v) {
    myData = v;
    return this;
  }

  public MemoryRange[] getReads() {
    return myReads;
  }

  public MemoryInfo setReads(MemoryRange[] v) {
    myReads = v;
    return this;
  }

  public MemoryRange[] getWrites() {
    return myWrites;
  }

  public MemoryInfo setWrites(MemoryRange[] v) {
    myWrites = v;
    return this;
  }

  public MemoryRange[] getObserved() {
    return myObserved;
  }

  public MemoryInfo setObserved(MemoryRange[] v) {
    myObserved = v;
    return this;
  }

  @Override @NotNull
  public BinaryClass klass() { return Klass.INSTANCE; }


  private static final Entity ENTITY = new Entity("service", "MemoryInfo", "", "");

  static {
    ENTITY.setFields(new Field[]{
      new Field("Data", new Slice("", new Primitive("uint8", Method.Uint8))),
      new Field("Reads", new Slice("memory.RangeList", new Struct(MemoryRange.Klass.INSTANCE.entity()))),
      new Field("Writes", new Slice("memory.RangeList", new Struct(MemoryRange.Klass.INSTANCE.entity()))),
      new Field("Observed", new Slice("memory.RangeList", new Struct(MemoryRange.Klass.INSTANCE.entity()))),
    });
    Namespace.register(Klass.INSTANCE);
  }
  public static void register() {}
  //<<<End:Java.ClassBody:1>>>
  public enum Klass implements BinaryClass {
    //<<<Start:Java.KlassBody:2>>>
    INSTANCE;

    @Override @NotNull
    public Entity entity() { return ENTITY; }

    @Override @NotNull
    public BinaryObject create() { return new MemoryInfo(); }

    @Override
    public void encode(@NotNull Encoder e, BinaryObject obj) throws IOException {
      MemoryInfo o = (MemoryInfo)obj;
      e.uint32(o.myData.length);
      e.write(o.myData, o.myData.length);

      e.uint32(o.myReads.length);
      for (int i = 0; i < o.myReads.length; i++) {
        e.value(o.myReads[i]);
      }
      e.uint32(o.myWrites.length);
      for (int i = 0; i < o.myWrites.length; i++) {
        e.value(o.myWrites[i]);
      }
      e.uint32(o.myObserved.length);
      for (int i = 0; i < o.myObserved.length; i++) {
        e.value(o.myObserved[i]);
      }
    }

    @Override
    public void decode(@NotNull Decoder d, BinaryObject obj) throws IOException {
      MemoryInfo o = (MemoryInfo)obj;
      o.myData = new byte[d.uint32()];
      d.read(o.myData, o.myData.length);

      o.myReads = new MemoryRange[d.uint32()];
      for (int i = 0; i <o.myReads.length; i++) {
        o.myReads[i] = new MemoryRange();
        d.value(o.myReads[i]);
      }
      o.myWrites = new MemoryRange[d.uint32()];
      for (int i = 0; i <o.myWrites.length; i++) {
        o.myWrites[i] = new MemoryRange();
        d.value(o.myWrites[i]);
      }
      o.myObserved = new MemoryRange[d.uint32()];
      for (int i = 0; i <o.myObserved.length; i++) {
        o.myObserved[i] = new MemoryRange();
        d.value(o.myObserved[i]);
      }
    }
    //<<<End:Java.KlassBody:2>>>
  }
}
