/*
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * THIS FILE WAS GENERATED BY codergen. EDIT WITH CARE.
 */
package com.android.tools.idea.editors.gfxtrace.service.stringtable;

import org.jetbrains.annotations.NotNull;

import com.android.tools.rpclib.binary.*;
import com.android.tools.rpclib.schema.*;

import java.io.IOException;

public final class List extends Node implements BinaryObject {
  @Override
  public String getString(java.util.Map<String, BinaryObject> arguments) {
    StringBuilder sb = new StringBuilder();
    for (Node n : myItems) {
      sb.append("• ");
      sb.append(n.getString(arguments));
      sb.append('\n');
    }
    return sb.toString();
  }

  //<<<Start:Java.ClassBody:1>>>
  private Node[] myItems;

  // Constructs a default-initialized {@link List}.
  public List() {}


  public Node[] getItems() {
    return myItems;
  }

  public List setItems(Node[] v) {
    myItems = v;
    return this;
  }

  @Override @NotNull
  public BinaryClass klass() { return Klass.INSTANCE; }


  private static final Entity ENTITY = new Entity("stringtable", "List", "", "");

  static {
    ENTITY.setFields(new Field[]{
      new Field("Items", new Slice("", new Interface("Node"))),
    });
    Namespace.register(Klass.INSTANCE);
  }
  public static void register() {}
  //<<<End:Java.ClassBody:1>>>
  public enum Klass implements BinaryClass {
    //<<<Start:Java.KlassBody:2>>>
    INSTANCE;

    @Override @NotNull
    public Entity entity() { return ENTITY; }

    @Override @NotNull
    public BinaryObject create() { return new List(); }

    @Override
    public void encode(@NotNull Encoder e, BinaryObject obj) throws IOException {
      List o = (List)obj;
      e.uint32(o.myItems.length);
      for (int i = 0; i < o.myItems.length; i++) {
        e.object(o.myItems[i].unwrap());
      }
    }

    @Override
    public void decode(@NotNull Decoder d, BinaryObject obj) throws IOException {
      List o = (List)obj;
      o.myItems = new Node[d.uint32()];
      for (int i = 0; i <o.myItems.length; i++) {
        o.myItems[i] = Node.wrap(d.object());
      }
    }
    //<<<End:Java.KlassBody:2>>>
  }
}
