/*
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * THIS FILE WAS GENERATED BY codergen. EDIT WITH CARE.
 */
package com.android.tools.idea.editors.gfxtrace.service.vertex;

import com.android.tools.idea.editors.gfxtrace.service.path.VertexStreamDataPath;
import org.jetbrains.annotations.NotNull;

import com.android.tools.rpclib.binary.*;
import com.android.tools.rpclib.schema.*;

import java.io.IOException;

public final class VertexStream implements BinaryObject {
  //<<<Start:Java.ClassBody:1>>>
  private String myName;
  private Format myFormat;
  private Semantic mySemantic;
  private VertexStreamDataPath myData;

  // Constructs a default-initialized {@link VertexStream}.
  public VertexStream() {}


  public String getName() {
    return myName;
  }

  public VertexStream setName(String v) {
    myName = v;
    return this;
  }

  public Format getFormat() {
    return myFormat;
  }

  public VertexStream setFormat(Format v) {
    myFormat = v;
    return this;
  }

  public Semantic getSemantic() {
    return mySemantic;
  }

  public VertexStream setSemantic(Semantic v) {
    mySemantic = v;
    return this;
  }

  public VertexStreamDataPath getData() {
    return myData;
  }

  public VertexStream setData(VertexStreamDataPath v) {
    myData = v;
    return this;
  }

  @Override @NotNull
  public BinaryClass klass() { return Klass.INSTANCE; }


  private static final Entity ENTITY = new Entity("vertex", "Stream", "", "");

  static {
    ENTITY.setFields(new Field[]{
      new Field("Name", new Primitive("string", Method.String)),
      new Field("Format", new Interface("Format")),
      new Field("Semantic", new Struct(Semantic.Klass.INSTANCE.entity())),
      new Field("Data", new Pointer(new Struct(VertexStreamDataPath.Klass.INSTANCE.entity()))),
    });
    Namespace.register(Klass.INSTANCE);
  }
  public static void register() {}
  //<<<End:Java.ClassBody:1>>>
  public enum Klass implements BinaryClass {
    //<<<Start:Java.KlassBody:2>>>
    INSTANCE;

    @Override @NotNull
    public Entity entity() { return ENTITY; }

    @Override @NotNull
    public BinaryObject create() { return new VertexStream(); }

    @Override
    public void encode(@NotNull Encoder e, BinaryObject obj) throws IOException {
      VertexStream o = (VertexStream)obj;
      e.string(o.myName);
      e.object(o.myFormat.unwrap());
      e.value(o.mySemantic);
      e.object(o.myData);
    }

    @Override
    public void decode(@NotNull Decoder d, BinaryObject obj) throws IOException {
      VertexStream o = (VertexStream)obj;
      o.myName = d.string();
      o.myFormat = Format.wrap(d.object());
      o.mySemantic = new Semantic();
      d.value(o.mySemantic);
      o.myData = (VertexStreamDataPath)d.object();
    }
    //<<<End:Java.KlassBody:2>>>
  }
}
